Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h	(revision 122)
@@ -28,10 +28,16 @@
     {
       ROB_EMPTY                      , // 
+
       ROB_BRANCH_WAIT_END            , // 
       ROB_BRANCH_COMPLETE            , // 
-      ROB_STORE_WAIT_HEAD_OK         , // 
-//    ROB_STORE_WAIT_HEAD_KO         , // 
-      ROB_STORE_HEAD_OK              , // 
-      ROB_STORE_HEAD_KO              , // 
+
+      ROB_STORE_WAIT_END_OK          , // 
+      ROB_STORE_WAIT_END_KO          , // 
+      ROB_STORE_OK                   , // 
+      ROB_STORE_KO                   , // 
+      ROB_STORE_OK_WAIT_END          , // 
+      ROB_STORE_KO_WAIT_END          , // 
+      ROB_STORE_EVENT                , // 
+
       ROB_OTHER_WAIT_END             , // 
 
@@ -50,11 +56,24 @@
       ROB_END_EXCEPTION_WAIT_HEAD    , // 
       ROB_END_EXCEPTION_UPDATE       , // 
-      ROB_END_EXCEPTION                // 
+      ROB_END_EXCEPTION              , // 
+      ROB_END
+    } rob_state_t;
 
-    } rob_state_t;
+  typedef enum
+    {
+      COMMIT_EVENT_STATE_NO_EVENT  ,
+      COMMIT_EVENT_STATE_EVENT     ,
+      COMMIT_EVENT_STATE_WAIT_DECOD,
+      COMMIT_EVENT_STATE_WAIT_END  ,
+      COMMIT_EVENT_STATE_END     
+    } Tcommit_event_state_t;
+
+#define commit_event_state_to_event_state(x) ((x==COMMIT_EVENT_STATE_EVENT)?EVENT_STATE_EVENT:((x==COMMIT_EVENT_STATE_WAIT_DECOD)?EVENT_STATE_WAITEND:((x==COMMIT_EVENT_STATE_WAIT_END)?EVENT_STATE_WAITEND:((x==COMMIT_EVENT_STATE_END)?EVENT_STATE_END:EVENT_STATE_NO_EVENT))))
+
 
   class entry_t 
   {
   public  : rob_state_t        state                   ;
+  public  : rob_state_t        state_old               ;
   public  : uint32_t           ptr                     ;
   public  : Tcontext_t         front_end_id            ;
@@ -98,4 +117,5 @@
 //public  : Tgeneral_data_t    data_commit             ; // branch's destination
 #ifdef DEBUG
+  public  : Tgeneral_data_t    load_data               ;
   public  : Taddress_t         address                 ;
 #endif
@@ -121,8 +141,10 @@
       case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_BRANCH_WAIT_END            : return "ROB_BRANCH_WAIT_END"             ; break;
       case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_BRANCH_COMPLETE            : return "ROB_BRANCH_COMPLETE"             ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_HEAD_OK         : return "ROB_STORE_WAIT_HEAD_OK"          ; break;
-//    case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_HEAD_KO         : return "ROB_STORE_WAIT_HEAD_KO"          ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_HEAD_OK              : return "ROB_STORE_HEAD_OK"               ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_HEAD_KO              : return "ROB_STORE_HEAD_KO"               ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_END_OK          : return "ROB_STORE_WAIT_END_OK"           ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_END_KO          : return "ROB_STORE_WAIT_END_KO"           ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_OK                   : return "ROB_STORE_OK"                    ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_KO                   : return "ROB_STORE_KO"                    ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_OK_WAIT_END          : return "ROB_STORE_OK_WAIT_END"           ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_KO_WAIT_END          : return "ROB_STORE_KO_WAIT_END"           ; break;
       case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_OTHER_WAIT_END             : return "ROB_OTHER_WAIT_END"              ; break;
       case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_EVENT_WAIT_END             : return "ROB_EVENT_WAIT_END"              ; break;
@@ -140,4 +162,5 @@
       case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_EXCEPTION_UPDATE       : return "ROB_END_EXCEPTION_UPDATE"        ; break;
       case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_EXCEPTION              : return "ROB_END_EXCEPTION"               ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END                        : return "ROB_END"                         ; break;
 
       default    : return ""      ; break;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 122)
@@ -141,4 +141,6 @@
       _ALLOC2_VALACK_IN ( in_RETIRE_EVENT_ACK               ,ACK,_param->_nb_front_end,_param->_nb_context[it1]);
       _ALLOC2_SIGNAL_OUT(out_RETIRE_EVENT_STATE             ,"state"                ,Tevent_state_t    ,_param->_size_event_state           ,_param->_nb_front_end,_param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_OUT(out_RETIRE_EVENT_FLUSH             ,"flush"                ,Tcontrol_t        ,1                                   ,_param->_nb_front_end,_param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_OUT(out_RETIRE_EVENT_STOP              ,"stop"                 ,Tcontrol_t        ,1                                   ,_param->_nb_front_end,_param->_nb_context[it1]);
 
       ALLOC2_INTERFACE_END(_param->_nb_front_end,_param->_nb_context[it1]);
@@ -306,21 +308,28 @@
 
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-    ALLOC2(_nb_cycle_idle           ,double        ,_param->_nb_front_end,_param->_nb_context [it1]);
-    ALLOC1(_rob                     ,std::list<entry_t*>,_param->_nb_bank);
+    ALLOC2(_nb_cycle_idle           ,double               ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC1(_rob                     ,std::list<entry_t*>  ,_param->_nb_bank);
     
-    ALLOC1(reg_BANK_PTR             ,uint32_t      ,_param->_nb_bank);
-
-    ALLOC2(reg_NB_INST_COMMIT_ALL   ,Tcounter_t    ,_param->_nb_front_end,_param->_nb_context [it1]);
-    ALLOC2(reg_NB_INST_COMMIT_MEM   ,Tcounter_t    ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC1(reg_BANK_PTR             ,uint32_t             ,_param->_nb_bank);
+                                                          
+    ALLOC2(reg_NB_INST_COMMIT_ALL   ,Tcounter_t           ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_NB_INST_COMMIT_MEM   ,Tcounter_t           ,_param->_nb_front_end,_param->_nb_context [it1]);
     
-    ALLOC2(reg_EVENT_STATE          ,Tevent_state_t,_param->_nb_front_end,_param->_nb_context [it1]);
-    ALLOC2(reg_EVENT_FLUSH          ,bool          ,_param->_nb_front_end,_param->_nb_context [it1]);
-    ALLOC2(reg_EVENT_STOP           ,bool          ,_param->_nb_front_end,_param->_nb_context [it1]);
-
-//  ALLOC2(reg_PC_PREVIOUS          ,Taddress_t    ,_param->_nb_front_end,_param->_nb_context [it1]);
-    ALLOC2(reg_PC_CURRENT           ,Taddress_t    ,_param->_nb_front_end,_param->_nb_context [it1]);
-    ALLOC2(reg_PC_CURRENT_IS_DS     ,Taddress_t    ,_param->_nb_front_end,_param->_nb_context [it1]);
-    ALLOC2(reg_PC_CURRENT_IS_DS_TAKE,Taddress_t    ,_param->_nb_front_end,_param->_nb_context [it1]);
-    ALLOC2(reg_PC_NEXT              ,Taddress_t    ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_EVENT_STATE          ,Tcommit_event_state_t,_param->_nb_front_end,_param->_nb_context [it1]);
+//  ALLOC2(reg_EVENT_FLUSH          ,bool                 ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_EVENT_STOP           ,bool                 ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_EVENT_NUM_BANK       ,uint32_t             ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_EVENT_NUM_PTR        ,uint32_t             ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_EVENT_CAN_RESTART    ,bool                 ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_EVENT_PACKET         ,uint32_t             ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_EVENT_LAST           ,bool                 ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_EVENT_LAST_NUM_BANK  ,uint32_t             ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_EVENT_LAST_NUM_PTR   ,uint32_t             ,_param->_nb_front_end,_param->_nb_context [it1]);
+                                                          
+//  ALLOC2(reg_PC_PREVIOUS          ,Taddress_t           ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_PC_CURRENT           ,Taddress_t           ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_PC_CURRENT_IS_DS     ,Taddress_t           ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_PC_CURRENT_IS_DS_TAKE,Taddress_t           ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_PC_NEXT              ,Taddress_t           ,_param->_nb_front_end,_param->_nb_context [it1]);
       }
 
@@ -345,4 +354,5 @@
       if (_param->_have_thread [i])
         {
+          
           std::string filename = morpheo::filename(MORPHEO_LOG,
                                                    "Instruction_flow-thread_"+toString(i),
@@ -351,7 +361,9 @@
                                                    false,
                                                    log_with_pid,
-                                                   false);
+                                                   true);
+
+          log_printf(TRACE,Commit_unit,FUNCTION,"KANE : %s",filename.c_str());
           
-          instruction_log_file [i] .open(filename.c_str() ,std::ios::out | std::ios::trunc);
+          instruction_log_file [i].open(filename.c_str() ,std::ios::out | std::ios::trunc);
         }
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_deallocation.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_deallocation.cpp	(revision 122)
@@ -94,4 +94,6 @@
         DELETE2_SIGNAL( in_RETIRE_EVENT_ACK               ,_param->_nb_front_end,_param->_nb_context[it1],1);
         DELETE2_SIGNAL(out_RETIRE_EVENT_STATE             ,_param->_nb_front_end,_param->_nb_context[it1],_param->_size_event_state);
+        DELETE2_SIGNAL(out_RETIRE_EVENT_FLUSH             ,_param->_nb_front_end,_param->_nb_context[it1],1);
+        DELETE2_SIGNAL(out_RETIRE_EVENT_STOP              ,_param->_nb_front_end,_param->_nb_context[it1],1);
 
         DELETE1_SIGNAL( in_COMMIT_VAL               ,_param->_nb_inst_commit,1                             );
@@ -202,7 +204,16 @@
         DELETE2(reg_NB_INST_COMMIT_ALL   ,_param->_nb_front_end,_param->_nb_context [it1]);
         DELETE2(reg_NB_INST_COMMIT_MEM   ,_param->_nb_front_end,_param->_nb_context [it1]);
+
         DELETE2(reg_EVENT_STATE          ,_param->_nb_front_end,_param->_nb_context [it1]);
-        DELETE2(reg_EVENT_FLUSH          ,_param->_nb_front_end,_param->_nb_context [it1]);
+//      DELETE2(reg_EVENT_FLUSH          ,_param->_nb_front_end,_param->_nb_context [it1]);
         DELETE2(reg_EVENT_STOP           ,_param->_nb_front_end,_param->_nb_context [it1]);
+        DELETE2(reg_EVENT_NUM_BANK       ,_param->_nb_front_end,_param->_nb_context [it1]);
+        DELETE2(reg_EVENT_NUM_PTR        ,_param->_nb_front_end,_param->_nb_context [it1]);
+        DELETE2(reg_EVENT_CAN_RESTART    ,_param->_nb_front_end,_param->_nb_context [it1]);
+        DELETE2(reg_EVENT_PACKET         ,_param->_nb_front_end,_param->_nb_context [it1]);
+        DELETE2(reg_EVENT_LAST           ,_param->_nb_front_end,_param->_nb_context [it1]);
+        DELETE2(reg_EVENT_LAST_NUM_BANK  ,_param->_nb_front_end,_param->_nb_context [it1]);
+        DELETE2(reg_EVENT_LAST_NUM_PTR   ,_param->_nb_front_end,_param->_nb_context [it1]);
+
 //      DELETE2(reg_PC_PREVIOUS          ,_param->_nb_front_end,_param->_nb_context [it1]);
         DELETE2(reg_PC_CURRENT           ,_param->_nb_front_end,_param->_nb_context [it1]);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_insert.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_insert.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_insert.cpp	(revision 122)
@@ -30,11 +30,13 @@
 #endif
     bool       can_rename_select [_param->_nb_rename_unit];
-    bool       event_stop;
-   
+//     bool       event_stop;
+    
+//     //     Initialisation
+//     event_stop = false; // one signal for all context.
+//     for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+//       for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+//         event_stop |= reg_EVENT_STOP [i][j];   
+
 //     Initialisation
-    event_stop = false; // one signal for all context.
-    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
-      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
-        event_stop |= reg_EVENT_STOP [i][j];
     for (uint32_t i=0; i<_param->_nb_bank; i++)
       {
@@ -57,5 +59,5 @@
 //     log_printf(TRACE,Commit_unit,FUNCTION,"  * reg_NUM_BANK_TAIL : %d",reg_NUM_BANK_TAIL);
 
-    if (not event_stop)
+//     if (not event_stop)
       {
         std::list<generic::priority::select_t> * select_insert = _priority_insert ->select(); // same select for all insert
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp	(revision 122)
@@ -56,4 +56,5 @@
 
         }
+
     // Scan Top of each bank
     internal_BANK_RETIRE_HEAD = reg_NUM_BANK_HEAD;
@@ -62,4 +63,5 @@
 	uint32_t num_bank = (internal_BANK_RETIRE_HEAD+i)%_param->_nb_bank;
 
+        // Test if have instruction
 	if (not _rob[num_bank].empty())
 	  {
@@ -68,5 +70,5 @@
 	    uint32_t   x     = entry->rename_unit_id;
 	    uint32_t   y     = num_inst_retire [x];
-	
+	    bool       bypass= false;
             // test if :
             //  * can retire (all previous instruction is retired)
@@ -77,4 +79,7 @@
 	      {
 		rob_state_t state        = entry->state;
+                Tcontext_t  front_end_id = entry->front_end_id;
+                Tcontext_t  context_id   = entry->context_id;  
+                
                   if ((state == ROB_END_OK         ) or 
                       (state == ROB_END_KO         ) or 
@@ -87,6 +92,4 @@
                       Tcontrol_t         write_re       = entry->write_re;
                       Tspecial_address_t num_reg_re_log = entry->num_reg_re_log;
-                      Tcontext_t         front_end_id   = entry->front_end_id;
-                      Tcontext_t         context_id     = entry->context_id;  
                       
                       // if state is ok, when write flags in the SR regsiters
@@ -173,8 +176,21 @@
                         can_retire [x] = false;
                     }
+
+                  bypass = ((state == ROB_END              ) or 
+                            (state == ROB_STORE_OK         ) or 
+                            (state == ROB_STORE_KO         ) or
+                            (state == ROB_STORE_OK_WAIT_END) or 
+                            (state == ROB_STORE_KO_WAIT_END));
+                  
+                  uint32_t packet = ((entry->ptr << _param->_shift_num_slot) | num_bank);
+
+                  // if future event, don't update after this event
+                  if (reg_EVENT_STOP [front_end_id][context_id] and
+                      (reg_EVENT_PACKET [entry->front_end_id][entry->context_id]  == packet))
+                    bypass = false;
 	      }
 
 	    // Retire "in-order"
-	    can_retire [x] &= retire_val [x][y];
+	    can_retire [x]  &= (retire_val [x][y] or bypass);
 	  }
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 122)
@@ -28,48 +28,83 @@
     // ===================================================================
     {
-      log_printf(TRACE,Commit_unit,FUNCTION,"  * REEXECUTE [0]");
-
-      // Store instruction comming Out Of Order in Load Store Unit. 
-      // Must be executed in no speculative mode. Also, send a signal when an Store is in head of ROB
-
-      Tcontrol_t val      = false;
-      uint32_t   num_bank = reg_NUM_BANK_HEAD;
-
-      if (not _rob[num_bank].empty())
+      uint32_t nb_scan_bank = 0; // last scan bank
+      bool     can_continue = true;
+
+      // for each reexecute_port
+      for (uint32_t i=0; i<_param->_nb_inst_reexecute; ++i)
 	{
-          log_printf(TRACE,Commit_unit,FUNCTION,"    * ROB is not empty");
-          log_printf(TRACE,Commit_unit,FUNCTION,"    * num_bank      : %d",num_bank);
-
-          entry_t    * entry = _rob [num_bank].front();
-	  rob_state_t  state = entry->state;
-
-          // Test state
-	  val   = ((state == ROB_STORE_HEAD_OK) or
-		   (state == ROB_STORE_HEAD_KO));
-
-          log_printf(TRACE,Commit_unit,FUNCTION,"    * val           : %d",val);
-	  if (val)
+	  log_printf(TRACE,Commit_unit,FUNCTION,"  * REEXECUTE [%d]",i);
+	  
+	  // Store instruction comming Out Of Order in Load Store Unit. 
+	  // Must be executed in no speculative mode. Also, send a signal when an Store is in head of ROB
+	  
+	  Tcontrol_t val = false;
+
+	  for (uint32_t j=nb_scan_bank; j<_param->_nb_bank; j++)
 	    {
-              Tpacket_t packet_id = ((entry->ptr << _param->_shift_num_slot) | num_bank);
-
-              log_printf(TRACE,Commit_unit,FUNCTION,"    * packet_id     : %d",packet_id);
-	  
-              // Reexecute store
-	      if (_param->_have_port_context_id)
-  	      PORT_WRITE(out_REEXECUTE_CONTEXT_ID            [0], entry->context_id           );
-	      if (_param->_have_port_front_end_id)
-  	      PORT_WRITE(out_REEXECUTE_FRONT_END_ID          [0], entry->front_end_id         );
-	      if (_param->_have_port_rob_ptr  )
-  	      PORT_WRITE(out_REEXECUTE_PACKET_ID             [0], packet_id                   );
-	      PORT_WRITE(out_REEXECUTE_TYPE                  [0], entry->type                 );
-	      PORT_WRITE(out_REEXECUTE_STORE_QUEUE_PTR_WRITE [0], entry->store_queue_ptr_write);
-	      PORT_WRITE(out_REEXECUTE_OPERATION             [0], (state == ROB_STORE_HEAD_OK)?OPERATION_MEMORY_STORE_HEAD_OK:OPERATION_MEMORY_STORE_HEAD_KO);
-	    }
+	      nb_scan_bank ++;
+	      
+              // translate bank number
+	      uint32_t num_bank = (reg_NUM_BANK_HEAD+j)%_param->_nb_bank;
+	      
+	      log_printf(TRACE,Commit_unit,FUNCTION,"    * num_bank      : %d",num_bank);
+
+	      // Test if the head of rob is not empty
+	      if (not _rob[num_bank].empty())
+		{
+		  log_printf(TRACE,Commit_unit,FUNCTION,"    * ROB is not empty");
+		  
+		  // Read state
+		  entry_t    * entry = _rob [num_bank].front();
+		  rob_state_t  state = entry->state;
+		  
+		  // Test state
+		  //  * store is ko, send signal at store_queue
+		  //  * store_is ok, test if in head
+// 		  val   = (((state == ROB_STORE_OK) and (num_bank == (reg_NUM_BANK_HEAD))) or
+// 			    (state == ROB_STORE_KO)  or
+// 			    (state == ROB_STORE_EVENT)
+// 			    );
+		  val   = (((state == ROB_STORE_OK) and can_continue) or
+			    (state == ROB_STORE_KO)  or
+			    (state == ROB_STORE_EVENT)
+			    );
+		  
+                  can_continue &= ((state == ROB_STORE_OK          ) or
+                                   (state == ROB_STORE_OK_WAIT_END ) or
+                                   (state == ROB_END_OK_SPECULATIVE) or
+                                   (state == ROB_END_OK            ) or
+                                   (state == ROB_END               )
+                                   );
+
+		  log_printf(TRACE,Commit_unit,FUNCTION,"    * val           : %d",val);
+
+		  if (val)
+		    {
+		      internal_REEXECUTE_NUM_BANK [i] = num_bank;
+
+		      Tpacket_t packet_id = ((entry->ptr << _param->_shift_num_slot) | num_bank);
+		      
+		      log_printf(TRACE,Commit_unit,FUNCTION,"    * packet_id     : %d",packet_id);
+		      
+		      // Reexecute store
+		      if (_param->_have_port_context_id)
+		      PORT_WRITE(out_REEXECUTE_CONTEXT_ID            [i], entry->context_id           );
+		      if (_param->_have_port_front_end_id)
+		      PORT_WRITE(out_REEXECUTE_FRONT_END_ID          [i], entry->front_end_id         );
+		      if (_param->_have_port_rob_ptr  )
+		      PORT_WRITE(out_REEXECUTE_PACKET_ID             [i], packet_id                   );
+		      PORT_WRITE(out_REEXECUTE_TYPE                  [i], entry->type                 );
+		      PORT_WRITE(out_REEXECUTE_STORE_QUEUE_PTR_WRITE [i], entry->store_queue_ptr_write);
+		      PORT_WRITE(out_REEXECUTE_OPERATION             [i], (state == ROB_STORE_OK)?OPERATION_MEMORY_STORE_HEAD_OK:OPERATION_MEMORY_STORE_HEAD_KO);
+
+		      break; // Stop scan
+		    }
+		}
+	    }  
+
+	  internal_REEXECUTE_VAL      [i] = val;
+	  PORT_WRITE(out_REEXECUTE_VAL[i], internal_REEXECUTE_VAL [i]);
 	}
- 
-      internal_REEXECUTE_VAL      [0] = val;
-      internal_REEXECUTE_NUM_BANK [0] = num_bank;
-      
-      PORT_WRITE(out_REEXECUTE_VAL[0], internal_REEXECUTE_VAL [0]);
     }
 
@@ -79,9 +114,12 @@
     {
       // Branchement must be send at the prediction unit
-      uint32_t nb_scan_bank = 0;
+
+      uint32_t nb_scan_bank = 0; // last scan bank
 
       // for each port, find a valid branchement.
       for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
 	{
+          log_printf(TRACE,Commit_unit,FUNCTION,"  * BRANCH_COMPLETE [%d]",i);
+
 	  Tcontrol_t  val  = false;
 	  
@@ -92,20 +130,65 @@
               // translate bank number
 	      uint32_t num_bank = (reg_NUM_BANK_HEAD+j)%_param->_nb_bank;
+
+              log_printf(TRACE,Commit_unit,FUNCTION,"    * num_bank           : %d",num_bank);
 	      
+              // Test if in this bank, they have an instruction
 	      if (not _rob [num_bank].empty())
 		{
+                  log_printf(TRACE,Commit_unit,FUNCTION,"    * not empty");
+
+                  // Read information
 		  entry_t    * entry    = _rob [num_bank].front();
 		  rob_state_t  state    = entry->state;
-		  
-		  if (state == ROB_BRANCH_COMPLETE)
+		  Tcontext_t   front_end_id = entry->front_end_id;
+		  Tcontext_t   context_id   = entry->context_id  ;
+
+                  log_printf(TRACE,Commit_unit,FUNCTION,"    * front_end_id       : %d",front_end_id);
+                  log_printf(TRACE,Commit_unit,FUNCTION,"    * context_id         : %d",context_id  );
+
+                  // don't complete a branch when rob manage an present event
+		  if ((reg_EVENT_STATE [front_end_id][context_id] == COMMIT_EVENT_STATE_NO_EVENT) and
+                      (state == ROB_BRANCH_COMPLETE))
 		    {
-		      val = true;
-		      
+                      log_printf(TRACE,Commit_unit,FUNCTION,"    * find !!!");
+
+                      // test if have a future event (stop is set)
+                      log_printf(TRACE,Commit_unit,FUNCTION,"      * reg_EVENT_STOP   : %d",reg_EVENT_STOP [front_end_id][context_id]);
+
+                      if (reg_EVENT_STOP [front_end_id][context_id])
+                        {
+                          // Have future event, can complete the branch if the event is most speculative than this branchement
+                          // Also, need compare packet_id (is order)
+
+                          uint32_t _top = ((_rob[reg_NUM_BANK_HEAD].front()->ptr << _param->_shift_num_slot) | reg_NUM_BANK_HEAD);
+                          uint32_t _old = reg_EVENT_PACKET [front_end_id][context_id];
+                          uint32_t _new = ((entry->ptr << _param->_shift_num_slot) | num_bank);
+
+//                           log_printf(TRACE,Commit_unit,FUNCTION,"      * _top             : %d",_top);
+//                           log_printf(TRACE,Commit_unit,FUNCTION,"      * _old (before)    : %d",_old);
+//                           log_printf(TRACE,Commit_unit,FUNCTION,"      * _new (before)    : %d",_new);
+
+                          if (_old < _top) _old = _old+_param->_size_queue;
+                          if (_new < _top) _new = _new+_param->_size_queue;
+                          if (_new < _old) val = true;
+
+//                           log_printf(TRACE,Commit_unit,FUNCTION,"      * _old (after )    : %d",_old);
+//                           log_printf(TRACE,Commit_unit,FUNCTION,"      * _new (after )    : %d",_new);
+
+                        }
+                      else
+                        val = true;
+		      
+                      log_printf(TRACE,Commit_unit,FUNCTION,"      * val              : %d",val);
+
+                      if (val)
+                        {
+                          // Have an valid branchement to complete
 		      internal_BRANCH_COMPLETE_NUM_BANK           [i] = num_bank;
 		      
+		      if (_param->_have_port_front_end_id)
+		      PORT_WRITE(out_BRANCH_COMPLETE_FRONT_END_ID [i],        front_end_id    );
 		      if (_param->_have_port_context_id)
-		      PORT_WRITE(out_BRANCH_COMPLETE_CONTEXT_ID   [i], entry->context_id      );
-		      if (_param->_have_port_front_end_id)
-		      PORT_WRITE(out_BRANCH_COMPLETE_FRONT_END_ID [i], entry->front_end_id    );
+		      PORT_WRITE(out_BRANCH_COMPLETE_CONTEXT_ID   [i],        context_id      );
 		      if (_param->_have_port_depth)
 		      PORT_WRITE(out_BRANCH_COMPLETE_DEPTH        [i], entry->depth           );
@@ -114,5 +197,6 @@
 		      PORT_WRITE(out_BRANCH_COMPLETE_NO_SEQUENCE  [i], entry->no_sequence     );
 		      
-		      break;
+		      break; // Stop scan
+                        }
 		    }
 		}
@@ -131,4 +215,5 @@
       internal_UPDATE_NUM_BANK = reg_NUM_BANK_HEAD;
 
+      // Test if have an instruction
       if (not _rob[internal_UPDATE_NUM_BANK].empty())
 	{
@@ -138,4 +223,6 @@
 	  entry_t * entry = _rob [internal_UPDATE_NUM_BANK].front();
 
+          // Test state
+          // Update if exception or load miss
           switch (entry->state)
             {
@@ -208,5 +295,14 @@
     for (uint32_t i=0; i<_param->_nb_front_end; i++)
       for (uint32_t j=0; j<_param->_nb_context [i]; j++)
-        PORT_WRITE(out_RETIRE_EVENT_STATE [i][j], reg_EVENT_STATE[i][j]);
+        {
+//        bool flush = reg_EVENT_FLUSH [i][j];
+          bool flush = (((reg_EVENT_STATE [i][j] == COMMIT_EVENT_STATE_EVENT) or
+                         (reg_EVENT_STATE [i][j] == COMMIT_EVENT_STATE_WAIT_DECOD)) and
+                        not reg_EVENT_CAN_RESTART[i][j]);
+
+          PORT_WRITE(out_RETIRE_EVENT_STATE [i][j], commit_event_state_to_event_state(reg_EVENT_STATE[i][j]));
+          PORT_WRITE(out_RETIRE_EVENT_FLUSH [i][j], flush);
+          PORT_WRITE(out_RETIRE_EVENT_STOP  [i][j], reg_EVENT_STOP [i][j]);
+        }
 
     log_end(Commit_unit,FUNCTION);
